kind: pipeline
type: docker
name: CI

trigger:
  when:
    branch:
      - master
      - dev
      - CI/CD
    event:
      - push

steps:
  - name: build-Models
    image: mcr.microsoft.com/dotnet/sdk:8.0
    commands:
      - cd source/Trek-12/Models
      - dotnet restore
      - dotnet build -c Release --no-restore
      - dotnet publish -c Release --no-restore -o $CI_PROJECT_DIR/build/release
  
  - name: build-ConsoleApp
    image: mcr.microsoft.com/dotnet/sdk:8.0
    commands:
      - cd source/Trek-12/ConsoleApp
      - dotnet restore
      - dotnet build -c Release --no-restore
      - dotnet publish -c Release --no-restore -o $CI_PROJECT_DIR/build/release
    depends_on: [build-Models]
  
  - name: tests
    image: mcr.microsoft.com/dotnet/sdk:8.0
    commands:
      - cd source/Trek-12
      - dotnet restore CI-Trek-12.sln
      - dotnet test CI-Trek-12.sln --no-restore
    depends_on: [build-Models]

  - name: code-analysis
    image: hub.codefirst.iut.uca.fr/marc.chevaldonne/codefirst-dronesonarplugin-dotnet8
    secrets: [ SECRET_SONAR_LOGIN ]
    settings:
      # accessible en ligne de commande par ${PLUGIN_SONAR_HOST}
      sonar_host: https://codefirst.iut.uca.fr/sonar/
      # accessible en ligne de commande par ${PLUGIN_SONAR_TOKEN}
      sonar_token:
        from_secret: SECRET_SONAR_LOGIN
    commands:
      - cd source/Trek-12
      - dotnet restore CI-Trek-12.sln
      - dotnet sonarscanner begin /k:"Trek-12" /d:sonar.host.url=$${PLUGIN_SONAR_HOST} /d:sonar.coverageReportPaths="coveragereport/SonarQube.xml" /d:sonar.coverage.exclusions="Tests/**" /d:sonar.login=$${PLUGIN_SONAR_TOKEN} 
      - dotnet build CI-Trek-12.sln -c Release --no-restore
      - dotnet test CI-Trek-12.sln --logger trx --no-restore /p:CollectCoverage=true /p:CoverletOutputFormat=cobertura --collect "XPlat Code Coverage"
      - reportgenerator -reports:"**/coverage.cobertura.xml" -reporttypes:SonarQube -targetdir:"coveragereport"
      - dotnet publish CI-Trek-12.sln -c Release --no-restore -o $CI_PROJECT_DIR/build/release
      - dotnet sonarscanner end /d:sonar.login=$${PLUGIN_SONAR_TOKEN}
    depends_on: [tests]

  - name: generate-and-deploy-docs
    image: hub.codefirst.iut.uca.fr/maxime.batista/codefirst-docdeployer:latest
    failure: ignore
    commands:
      - /entrypoint.sh -l doxygen -t doxygen
    when:
      branch:
        - master
        - dev
      event:
        - push
    depends_on: [ tests ]
